Gecode::Int::GCC::Val< Card > Class Template Reference
Other available functionality » Integer propagators

Value consistent global cardinality propagator. More...

`#include <gcc.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost funtion returning high linear.
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Destructor.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< IntView > &x, ViewArray< Card > &k)
| Post propagator for views x and cardinalities k.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| Val (Home home, ViewArray< IntView > &x, ViewArray< Card > &k)
| Constructor for posting.
| Val (Space &home, Val< Card > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< IntView > | x
| Views on which to perform value-propagation.
ViewArray< Card > | k
| Array containing either fixed cardinalities or CardViews.

## Detailed Description

template<class Card>
class Gecode::Int::GCC::Val< Card >

Value consistent global cardinality propagator.

Requires

#include <gecode/int/gcc.hh>
gcc.hh

Definition at line 63 of file gcc.hh.

## Constructor & Destructor Documentation

## Val() [1/2]

template<class Card>

Gecode::Int::GCC::Val< Card >::Val | ( | Home | home,
|  | ViewArray< IntView > & | x,
|  | ViewArray< Card > & | k )

inline protected

Constructor for posting.

Definition at line 43 of file val.hpp.

## Val() [2/2]

template<class Card>

Gecode::Int::GCC::Val< Card >::Val | ( | Space & | home,
|  | Val< Card > & | p )

inline protected

Constructor for cloning p.

Definition at line 52 of file val.hpp.

## Member Function Documentation

## copy()

template<class Card>

Actor * Gecode::Int::GCC::Val< Card >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 69 of file val.hpp.

## cost()

template<class Card>

PropCost Gecode::Int::GCC::Val< Card >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost funtion returning high linear.

Implements Gecode::Propagator.

Definition at line 75 of file val.hpp.

## reschedule()

template<class Card>

void Gecode::Int::GCC::Val< Card >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 85 of file val.hpp.

## propagate()

template<class Card>

ExecStatus Gecode::Int::GCC::Val< Card >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 281 of file val.hpp.

## dispose()

template<class Card>

size_t Gecode::Int::GCC::Val< Card >::dispose | ( | Space & | home | ) |

inline virtual

Destructor.

Reimplemented from Gecode::Actor.

Definition at line 60 of file val.hpp.

## post()

template<class Card>

ExecStatus Gecode::Int::GCC::Val< Card >::post | ( | Home | home,
|  | ViewArray< IntView > & | x,
|  | ViewArray< Card > & | k )

static

Post propagator for views x and cardinalities k.

Definition at line 287 of file val.hpp.

## Member Data Documentation

## x

template<class Card>

ViewArray<IntView> Gecode::Int::GCC::Val< Card >::x

protected

Views on which to perform value-propagation.

Definition at line 66 of file gcc.hh.

## k

template<class Card>

ViewArray<Card> Gecode::Int::GCC::Val< Card >::k

protected

Array containing either fixed cardinalities or CardViews.

Definition at line 68 of file gcc.hh.

The documentation for this class was generated from the following files:

- gecode/int/gcc.hh
- gecode/int/gcc/val.hpp